
_main:

;sahu.c,32 :: 		void main()
;sahu.c,35 :: 		TRISA = 0x39; // setting RA0 analog input & RA3 -RA5 digital i\p
	MOVLW      57
	MOVWF      TRISA+0
;sahu.c,36 :: 		TRISC = 0x00; // setting port C as output.
	CLRF       TRISC+0
;sahu.c,38 :: 		ADCON0=0x01;
	MOVLW      1
	MOVWF      ADCON0+0
;sahu.c,39 :: 		ADCON1=0x00;
	CLRF       ADCON1+0
;sahu.c,44 :: 		L2 = 1;// mains normal on
	BSF        RC4_bit+0, 4
;sahu.c,45 :: 		L1 = 0;// hi\lo cut off
	BCF        RC5_bit+0, 5
;sahu.c,46 :: 		BZR = 0;// SOUND off
	BCF        RC3_bit+0, 3
;sahu.c,47 :: 		RL4 = 0;// Output relay off R4
	BCF        RC2_bit+0, 2
;sahu.c,53 :: 		if(SW2 == 0)
	BTFSC      RA4_bit+0, 4
	GOTO       L_main0
;sahu.c,55 :: 		Delay_ms(5);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_main1:
	DECFSZ     R13+0, 1
	GOTO       L_main1
	DECFSZ     R12+0, 1
	GOTO       L_main1
	NOP
	NOP
;sahu.c,56 :: 		}
	GOTO       L_main2
L_main0:
;sahu.c,59 :: 		Delay_ms(1);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_main3:
	DECFSZ     R13+0, 1
	GOTO       L_main3
	DECFSZ     R12+0, 1
	GOTO       L_main3
	NOP
	NOP
;sahu.c,60 :: 		}
L_main2:
;sahu.c,65 :: 		L1 = 0; // delay indicator off.
	BCF        RC5_bit+0, 5
;sahu.c,66 :: 		while(1)
L_main4:
;sahu.c,68 :: 		ADC_Value = ADC_Read(0); // A/D conversion. Pin RA2 is an input.
	CLRF       FARG_ADC_Read_channel+0
	CALL       _ADC_Read+0
	MOVF       R0+0, 0
	MOVWF      _ADC_Value+0
	MOVF       R0+1, 0
	MOVWF      _ADC_Value+1
;sahu.c,69 :: 		tlong =(long)ADC_Value*5000; // Convert the result in millivolts
	MOVLW      0
	MOVWF      R0+2
	MOVWF      R0+3
	MOVLW      136
	MOVWF      R4+0
	MOVLW      19
	MOVWF      R4+1
	CLRF       R4+2
	CLRF       R4+3
	CALL       _Mul_32x32_U+0
	MOVF       R0+0, 0
	MOVWF      _tlong+0
	MOVF       R0+1, 0
	MOVWF      _tlong+1
	MOVF       R0+2, 0
	MOVWF      _tlong+2
	MOVF       R0+3, 0
	MOVWF      _tlong+3
;sahu.c,70 :: 		tlong = tlong/1023; // 0..1023 -> 0-5000mV
	MOVLW      255
	MOVWF      R4+0
	MOVLW      3
	MOVWF      R4+1
	CLRF       R4+2
	CLRF       R4+3
	CALL       _Div_32x32_S+0
	MOVF       R0+0, 0
	MOVWF      _tlong+0
	MOVF       R0+1, 0
	MOVWF      _tlong+1
	MOVF       R0+2, 0
	MOVWF      _tlong+2
	MOVF       R0+3, 0
	MOVWF      _tlong+3
;sahu.c,71 :: 		ch =(float)tlong/1000; // Extract volts (thousands of millivolts)
	CALL       _Longint2Double+0
	MOVLW      0
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVLW      122
	MOVWF      R4+2
	MOVLW      136
	MOVWF      R4+3
	CALL       _Div_32x32_FP+0
	MOVF       R0+0, 0
	MOVWF      _ch+0
	MOVF       R0+1, 0
	MOVWF      _ch+1
	MOVF       R0+2, 0
	MOVWF      _ch+2
	MOVF       R0+3, 0
	MOVWF      _ch+3
;sahu.c,77 :: 		if((ch<=4.60)&&(ch>=1.40))
	MOVF       R0+0, 0
	MOVWF      R4+0
	MOVF       R0+1, 0
	MOVWF      R4+1
	MOVF       R0+2, 0
	MOVWF      R4+2
	MOVF       R0+3, 0
	MOVWF      R4+3
	MOVLW      51
	MOVWF      R0+0
	MOVLW      51
	MOVWF      R0+1
	MOVLW      19
	MOVWF      R0+2
	MOVLW      129
	MOVWF      R0+3
	CALL       _Compare_Double+0
	MOVLW      1
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main8
	MOVLW      51
	MOVWF      R4+0
	MOVLW      51
	MOVWF      R4+1
	MOVLW      51
	MOVWF      R4+2
	MOVLW      127
	MOVWF      R4+3
	MOVF       _ch+0, 0
	MOVWF      R0+0
	MOVF       _ch+1, 0
	MOVWF      R0+1
	MOVF       _ch+2, 0
	MOVWF      R0+2
	MOVF       _ch+3, 0
	MOVWF      R0+3
	CALL       _Compare_Double+0
	MOVLW      1
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main8
L__main17:
;sahu.c,80 :: 		if(ch>4.65)
	MOVF       _ch+0, 0
	MOVWF      R4+0
	MOVF       _ch+1, 0
	MOVWF      R4+1
	MOVF       _ch+2, 0
	MOVWF      R4+2
	MOVF       _ch+3, 0
	MOVWF      R4+3
	MOVLW      205
	MOVWF      R0+0
	MOVLW      204
	MOVWF      R0+1
	MOVLW      20
	MOVWF      R0+2
	MOVLW      129
	MOVWF      R0+3
	CALL       _Compare_Double+0
	MOVLW      1
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main9
;sahu.c,82 :: 		if(ch>4.00)
	MOVF       _ch+0, 0
	MOVWF      R4+0
	MOVF       _ch+1, 0
	MOVWF      R4+1
	MOVF       _ch+2, 0
	MOVWF      R4+2
	MOVF       _ch+3, 0
	MOVWF      R4+3
	MOVLW      0
	MOVWF      R0+0
	MOVLW      0
	MOVWF      R0+1
	MOVLW      0
	MOVWF      R0+2
	MOVLW      129
	MOVWF      R0+3
	CALL       _Compare_Double+0
	MOVLW      1
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main10
;sahu.c,84 :: 		if(ch>3.65)
	MOVF       _ch+0, 0
	MOVWF      R4+0
	MOVF       _ch+1, 0
	MOVWF      R4+1
	MOVF       _ch+2, 0
	MOVWF      R4+2
	MOVF       _ch+3, 0
	MOVWF      R4+3
	MOVLW      154
	MOVWF      R0+0
	MOVLW      153
	MOVWF      R0+1
	MOVLW      105
	MOVWF      R0+2
	MOVLW      128
	MOVWF      R0+3
	CALL       _Compare_Double+0
	MOVLW      1
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main11
;sahu.c,86 :: 		if(ch>3.15)
	MOVF       _ch+0, 0
	MOVWF      R4+0
	MOVF       _ch+1, 0
	MOVWF      R4+1
	MOVF       _ch+2, 0
	MOVWF      R4+2
	MOVF       _ch+3, 0
	MOVWF      R4+3
	MOVLW      154
	MOVWF      R0+0
	MOVLW      153
	MOVWF      R0+1
	MOVLW      73
	MOVWF      R0+2
	MOVLW      128
	MOVWF      R0+3
	CALL       _Compare_Double+0
	MOVLW      1
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main12
;sahu.c,88 :: 		if(ch>2.56)
	MOVF       _ch+0, 0
	MOVWF      R4+0
	MOVF       _ch+1, 0
	MOVWF      R4+1
	MOVF       _ch+2, 0
	MOVWF      R4+2
	MOVF       _ch+3, 0
	MOVWF      R4+3
	MOVLW      10
	MOVWF      R0+0
	MOVLW      215
	MOVWF      R0+1
	MOVLW      35
	MOVWF      R0+2
	MOVLW      128
	MOVWF      R0+3
	CALL       _Compare_Double+0
	MOVLW      1
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main13
;sahu.c,90 :: 		if(ch>1.48)
	MOVF       _ch+0, 0
	MOVWF      R4+0
	MOVF       _ch+1, 0
	MOVWF      R4+1
	MOVF       _ch+2, 0
	MOVWF      R4+2
	MOVF       _ch+3, 0
	MOVWF      R4+3
	MOVLW      164
	MOVWF      R0+0
	MOVLW      112
	MOVWF      R0+1
	MOVLW      61
	MOVWF      R0+2
	MOVLW      127
	MOVWF      R0+3
	CALL       _Compare_Double+0
	MOVLW      1
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main14
;sahu.c,94 :: 		RL5 = 1;
	BSF        RA2_bit+0, 2
;sahu.c,95 :: 		RL3 = 1;
	BSF        RC1_bit+0, 1
;sahu.c,96 :: 		RL2 = 1;
	BSF        RC0_bit+0, 0
;sahu.c,97 :: 		RL1 = 0;//STP7
	BCF        RA1_bit+0, 1
;sahu.c,98 :: 		}
L_main14:
;sahu.c,100 :: 		RL5 = 1;
	BSF        RA2_bit+0, 2
;sahu.c,101 :: 		RL2 = 1;
	BSF        RC0_bit+0, 0
;sahu.c,102 :: 		RL1 = 0;
	BCF        RA1_bit+0, 1
;sahu.c,103 :: 		RL3 = 0;//STP6
	BCF        RC1_bit+0, 1
;sahu.c,104 :: 		}
L_main13:
;sahu.c,106 :: 		RL3 = 1;
	BSF        RC1_bit+0, 1
;sahu.c,107 :: 		RL2 = 1;
	BSF        RC0_bit+0, 0
;sahu.c,108 :: 		RL1 = 0;
	BCF        RA1_bit+0, 1
;sahu.c,109 :: 		RL5 = 0;//STP5
	BCF        RA2_bit+0, 2
;sahu.c,110 :: 		}
L_main12:
;sahu.c,112 :: 		RL2 = 1;
	BSF        RC0_bit+0, 0
;sahu.c,113 :: 		RL1 = 0;
	BCF        RA1_bit+0, 1
;sahu.c,114 :: 		RL5 = 0;
	BCF        RA2_bit+0, 2
;sahu.c,115 :: 		RL3 = 0;//STP4
	BCF        RC1_bit+0, 1
;sahu.c,116 :: 		}
L_main11:
;sahu.c,118 :: 		RL3 = 1;
	BSF        RC1_bit+0, 1
;sahu.c,119 :: 		RL1 = 0;
	BCF        RA1_bit+0, 1
;sahu.c,120 :: 		RL5 = 0;
	BCF        RA2_bit+0, 2
;sahu.c,121 :: 		RL2 = 0;//STP3
	BCF        RC0_bit+0, 0
;sahu.c,122 :: 		}
L_main10:
;sahu.c,124 :: 		RL1 = 0;
	BCF        RA1_bit+0, 1
;sahu.c,125 :: 		RL3 = 1;
	BSF        RC1_bit+0, 1
;sahu.c,126 :: 		RL5 = 0;
	BCF        RA2_bit+0, 2
;sahu.c,127 :: 		RL2 = 0;//STP2
	BCF        RC0_bit+0, 0
;sahu.c,128 :: 		}
L_main9:
;sahu.c,130 :: 		RL3 = 1;
	BSF        RC1_bit+0, 1
;sahu.c,131 :: 		RL1 = 0;
	BCF        RA1_bit+0, 1
;sahu.c,132 :: 		RL5 = 0;
	BCF        RA2_bit+0, 2
;sahu.c,133 :: 		RL2 = 0;//STP1
	BCF        RC0_bit+0, 0
;sahu.c,134 :: 		}
L_main8:
;sahu.c,136 :: 		RL5 = 1;
	BSF        RA2_bit+0, 2
;sahu.c,137 :: 		RL3 = 1;
	BSF        RC1_bit+0, 1
;sahu.c,138 :: 		RL2 = 1;
	BSF        RC0_bit+0, 0
;sahu.c,139 :: 		RL1 = 0;
	BCF        RA1_bit+0, 1
;sahu.c,141 :: 		RL4 = 1;// output relay on.
	BSF        RC2_bit+0, 2
;sahu.c,142 :: 		L2 = 1; // mains indicator on
	BSF        RC4_bit+0, 4
;sahu.c,143 :: 		L1 = 0; // high //low voltage indicator off
	BCF        RC5_bit+0, 5
;sahu.c,144 :: 		BZR = 0; // high //low voltage indicator off
	BCF        RC3_bit+0, 3
;sahu.c,146 :: 		}
	GOTO       L_main4
;sahu.c,173 :: 		}  // End main()
	GOTO       $+0
; end of _main
